
#Distribuci Normal

#Aquest programa mostra l'evoluci de l'EQM graficant
#l'eix EQM amb una escala comuna per a tots els estimadors.
#davant canvis en sigma i n de tres estimdadors
#1er estimador. Mitjana Mostral
#2on estimador. sumatori Xi partit per (n-1)
#3er estimador. sumatori Xi partit per (n+1)

#Fixem la llavor per a que l'experiment sempre surti el mateix

set.seed(1000)

#Creem la matriu

rep<-500
mostra<-50
nvars<-seq(3,mostra,1)
mu<-10
sigma<-nvars/10


#Creem els vectors necessaris de la Mitjana Mostral
e_mu0.hat<-vector()
b_mu0.hat<-vector()
v_mu0.hat<-vector()
eqm_mu0.hat<-vector()
e2_mu0.hat<-vector()
b2_mu0.hat<-vector()
v2_mu0.hat<-vector()
eqm2_mu0.hat<-vector()


#Creem els vectors necessaris del primer estimador
e_mu1.hat<-vector()
b_mu1.hat<-vector()
v_mu1.hat<-vector()
eqm_mu1.hat<-vector()
e2_mu1.hat<-vector()
b2_mu1.hat<-vector()
v2_mu1.hat<-vector()
eqm2_mu1.hat<-vector()

#Creem els vectors necessaris del segon estimador
e_mu2.hat<-vector()
b_mu2.hat<-vector()
v_mu2.hat<-vector()
eqm_mu2.hat<-vector()
e2_mu2.hat<-vector()
b2_mu2.hat<-vector()
v2_mu2.hat<-vector()
eqm2_mu2.hat<-vector()

for (i in 1:length(nvars)){
for (j in 1:length(sigma)){
	matriu<-matrix(rnorm(rep*nvars[i],mu,sigma[j]),rep)
#Mitjana mostral
	mu0.hat<-rowMeans(matriu)
	e_mu0.hat[i]<-mean(mu0.hat)
	v_mu0.hat[i]<-var(mu0.hat)
	b_mu0.hat[i]<-mean(mu0.hat)-mu
	eqm_mu0.hat[i]<-b_mu0.hat[i]^2+v_mu0.hat[i]
	e2_mu0.hat<-rbind(e2_mu0.hat,e_mu0.hat[i])
	b2_mu0.hat<-rbind(b2_mu0.hat,b_mu0.hat[i])
	v2_mu0.hat<-rbind(v2_mu0.hat,v_mu0.hat[i])
	eqm2_mu0.hat<-rbind(eqm2_mu0.hat,eqm_mu0.hat[i])
#Primer estadstic
	mu1.hat<-rowSums(matriu)/(nvars[i]-1)
	e_mu1.hat[i]<-mean(mu1.hat)
	v_mu1.hat[i]<-var(mu1.hat)
	b_mu1.hat[i]<-mean(mu1.hat)-mu
	eqm_mu1.hat[i]<-b_mu1.hat[i]^2+v_mu1.hat[i]
	e2_mu1.hat<-rbind(e2_mu1.hat,e_mu1.hat[i])
	b2_mu1.hat<-rbind(b2_mu1.hat,b_mu1.hat[i])
	v2_mu1.hat<-rbind(v2_mu1.hat,v_mu1.hat[i])
	eqm2_mu1.hat<-rbind(eqm2_mu1.hat,eqm_mu1.hat[i])
#Segon estadstic
	mu2.hat<-rowSums(matriu)/(nvars[i]+1)
	e_mu2.hat[i]<-mean(mu2.hat)
	v_mu2.hat[i]<-var(mu2.hat)
	b_mu2.hat[i]<-mean(mu2.hat)-mu
	eqm_mu2.hat[i]<-b_mu2.hat[i]^2+v_mu2.hat[i]
	e2_mu2.hat<-rbind(e2_mu2.hat,e_mu2.hat[i])
	b2_mu2.hat<-rbind(b2_mu2.hat,b_mu2.hat[i])
	v2_mu2.hat<-rbind(v2_mu2.hat,v_mu2.hat[i])
	eqm2_mu2.hat<-rbind(eqm2_mu2.hat,eqm_mu2.hat[i])
}
}
res0<-cbind(e2_mu0.hat,b2_mu0.hat,v2_mu0.hat,eqm2_mu0.hat)
res1<-cbind(e2_mu1.hat,b2_mu1.hat,v2_mu1.hat,eqm2_mu1.hat)
res2<-cbind(e2_mu2.hat,b2_mu2.hat,v2_mu2.hat,eqm2_mu2.hat)
nomscol<-c("Esperana", "Biaix", "Varincia", "EQM")
colnames(res0)<-nomscol
colnames(res1)<-nomscol
colnames(res2)<-nomscol
res0; res1; res2;

#Anlisi grfica.
#Generem una matriu grfica d'una fila i dues columnes

dades_mu0_1<-matrix(eqm2_mu0.hat, nrow=length(sigma), ncol=length(nvars))
dades_mu1_1<-matrix(eqm2_mu1.hat, nrow=length(sigma), ncol=length(nvars))
dades_mu2_1<-matrix(eqm2_mu2.hat, nrow=length(sigma), ncol=length(nvars))

dades_mu0_2<-matrix(b2_mu0.hat^2, nrow=length(sigma), ncol=length(nvars))
dades_mu1_2<-matrix(b2_mu1.hat^2, nrow=length(sigma), ncol=length(nvars))
dades_mu2_2<-matrix(b2_mu2.hat^2, nrow=length(sigma), ncol=length(nvars))

dades_mu0_3<-matrix(v2_mu0.hat, nrow=length(sigma), ncol=length(nvars))
dades_mu1_3<-matrix(v2_mu1.hat, nrow=length(sigma), ncol=length(nvars))
dades_mu2_3<-matrix(v2_mu2.hat, nrow=length(sigma), ncol=length(nvars))


zlim<-c(max(dades_mu0_1,dades_mu1_1,dades_mu2_1),min(dades_mu0_1,dades_mu1_1,dades_mu2_1))

par(mfrow = c(1,3), oma=c(1, 0, 4, 0))
persp(sigma,nvars,dades_mu0_1, theta=60, xlab='Sigma poblaci', ylab='Mida Mostral', zlab='EQM', col='red', zlim=range(zlim), main='Mitjana Mostral')
persp(sigma,nvars,dades_mu1_1, theta=60, xlab='Sigma poblaci', ylab='Mida Mostral', zlab='EQM', col='blue', zlim=range(zlim), main='Estimador 1')
persp(sigma,nvars,dades_mu2_1, theta=60, xlab='Sigma polbaci', ylab='Mida Mostral', zlab='EQM', col='violet', zlim=range(zlim), main='Estimador 2')
mtext(side=3, line=0, cex=1.5, outer=T,"Exercici 2.7. EQM. Escala comuna per a tots els estimadors")
